$(document).ready(function() {
	$("#select").click( function() {
		selectAll();
	});

	$("#copy").click(cmdCopyItems);

	$("#paste").click(cmdPasteItems);

	$('#undo').click(function() {
		sendUndoPresentation('undo');
	});
	$('#redo').click(function() {
		sendUndoPresentation('redo');
	});
	shortcut.add('Ctrl+Z', function() {
		sendUndoPresentation('undo');
	}, {'disable_in_input':true});
	shortcut.add('Ctrl+Y', function() {
		sendUndoPresentation('redo');
	}, {'disable_in_input':true});

    shortcut.add("Ctrl+C", cmdCopyItems, {'disable_in_input':true});
    shortcut.add("Ctrl+V", cmdPasteItems, {'disable_in_input':true});
    shortcut.add("Ctrl+A", selectAll, {'disable_in_input':true});
    
    shortcut.add("Ctrl+left",function(event){moveSelected(event,-1,0);}, {'disable_in_input':true,'propagate':true});
    shortcut.add("Ctrl+right",function(event){moveSelected(event,+1,0);}, {'disable_in_input':true,'propagate':true});
    shortcut.add("Ctrl+up",function(event){moveSelected(event,0,-1);}, {'disable_in_input':true,'propagate':true});
    shortcut.add("Ctrl+down",function(event){moveSelected(event,0,+1);}, {'disable_in_input':true,'propagate':true});

    shortcut.add("left",function(event){moveSelected(event,-10,0);}, {'disable_in_input':true,'propagate':true});
    shortcut.add("right",function(event){moveSelected(event,+10,0);}, {'disable_in_input':true,'propagate':true});
    shortcut.add("up",function(event){moveSelected(event,0,-10);}, {'disable_in_input':true,'propagate':true});
    shortcut.add("down",function(event){moveSelected(event,0,+10);}, {'disable_in_input':true,'propagate':true});
  
    
    //zablokujskalowanie okna przegladarki
    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':43}); //+ Opera
    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':107}); //+ FF,IE
    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':45}); //- Opera
    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':109}); //- FF,IE

    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':61}); //+= FF,
    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':187}); //+= Chrome
    shortcut.add("Ctrl+",browserKeypressIgnored,{'keycode':189}); //-_ Chrome
    
});

function browserKeypressIgnored(){}


function shortcutStopPropagation(event){
    //nothing selected
    if(event) {
        event.cancelBubble = true;
        event.returnValue = false;

        //e.stopPropagation works in Firefox.
        if (event.stopPropagation) {
            event.stopPropagation();
            event.preventDefault();
        }
    }
    return false;    
}

/* zwraca array: [dopasowanie, liczba, jednostka]*/
function splitUnits(str) {
    str = $.trim(str);
    var re = /^(-?\d+)(.*)$/;
    var found = str.match( re );
    if(found) found[1] = parseInt(found[1]);
    return found;
}

function moveSelectionCornersTo(x,y) {
    var cornerLT = document.getElementById('lt_corner');
    var dx = x - cornerLT.cx.baseVal.value
    var dy = y - cornerLT.cy.baseVal.value
    moveSelectionCorners(dx,dy);
}

function moveSelectionCorners(dx,dy) {
    var corners = ['lt_corner','lb_corner','rt_corner','rb_corner',
                'line_ct', 'line_cb', 'line_cl', 'line_cr',
                'line_1', 'line_2'];
    var id, elem;
    for (var i=0; i<corners.length; i++) {
        id = corners[i];
        elem = document.getElementById(id);
        if(elem && 'raphael' in elem)
            elem.raphael.translate(dx,dy);
    }
}

function moveSelected(event,dx,dy) {
    if(selectedItems != "" && selectedItems instanceof Object) {

        return shortcutStopPropagation(event);
    } else if(activeObj != "") {
        var result = shortcutStopPropagation(event);
        
        //console.log(activeObj);
        var jqObj = $("#"+activeObj);
        var domObj = jqObj.get(0);       

        var typePrefix = activeObj.substr(0,4);
        if('raphael' in domObj) {
            domObj.raphael.translate(dx,dy);
            moveSelectionCorners(dx,dy);
            if("rect"==typePrefix || "math"==typePrefix || "imag"==typePrefix || "movi"==typePrefix) {
                up2.call( domObj.raphael );
            } else if("circ"==typePrefix || "elli"==typePrefix) {
                up1.call( domObj.raphael );
            } else {
                console.log("unknown Raphael translate: "+activeObj);
            }
        } else if("text"==typePrefix){
            moveSelectionCorners(dx,dy);
            var strX = jqObj.css("left");
            var arrX = splitUnits(strX);
            var x = dx + arrX[1];
            var strY = jqObj.css("top");
            var arrY = splitUnits(strY);
            var y = dy + arrY[1];
            //licze w jednostkach w jakich bylo wpisane
            jqObj.css("left", x+arrX[2]); //przesun na ekranie
            jqObj.css("top", y+arrY[2]);
            textDivMoved(event, activeObj, x, y); //zapisz zmiany
        } else {
            console.log("unknown obj for translate: "+activeObj);
        }        
        //var acx = jqobj.attr("x");
        //jqobj.attr("x",acx);
     
        return result;
    } else {

    return true;  
 }
}

function sendUndoPresentation(direction) {
	waitingOverlay('on');

	$.ajax({
		type: 'POST',
		url: serverName + '?page=presentations&cl=undoPresentation',
		data: {
			pId: project,
			cmd: direction
		},
		success: function(response) {
			if(response.success === true) {
				waitingOverlay('off');
				changeWorkContent(response.id);
			}
			/*
			if(response === null || response.success !== true) {
				customAlert("problem. odśwież stronę");
			} else {            
				if(response.reload) {
					reloadStylesheets();
					reloadSlideMenu();
				} else if(response.reloadThumbs) {
					reloadSlideMenu();
				}

				if(response.sheetId) {
					changeWorkContent(response.sheetId);
				} else {
					changeWorkContent(lastID);
				}
			}
			waitingOverlay('off');
			*/
		},
		error: function(xhr, status, error) {
			waitingOverlay('off');
		},
		complete: function(){
		}
	});
}

/**
 * cmdCopyItems
 * @returns {undefined}
 */
function cmdCopyItems() {
	copyItems = new Array();

	if(activeObj) {
		var copyItem = document.getElementById(activeObj);
		copyItems[0] = copyItem.parentNode;
	} else if(selectedItems.length > 0) {
		copyItems = selectedItems;
		activeObj = '';
	} else {
		customAlert("Wybierz obiekt który chcesz skopiować.");
	}

	/*
	tmpArr = new Array();

	if(selectedItems != "" && selectedItems instanceof Object) {
		$.each(selectedItems, function(index, value) { 
			if(value.name != undefined) {
				tmpArr[index] = $.parseJSON(copy(value.name));
			}
		});
	} else {
		if((activeObj == null) || (activeObj == "")) {
			customAlert("Wybierz obiekt który chcesz skopiować.");
		} else {
			tmpArr[0] = $.parseJSON(copy(activeObj));
			copyItems = jQuery.toJSON(tmpArr);
		}
	}
	*/
}

function refreshSheetContent() {
	iloscObiektow = 0;
	objectLayers = '';
	sheetLayers = new Array();

	$.each($('#workplace').find('#workarea g'), function() {
		var groupNodes = this.childNodes;
		for(var i = 0; i < groupNodes.length; ++i) {
			var element = groupNodes[i];
			bindElement(element, false);
		}
	});

	var layerlist = $('#layerList');
	layerlist.html('');

	if(sheetLayers.length > 0) {
		var sheetLayersCopy = sheetLayers.slice();
		sheetLayersCopy.reverse();

		for(var i = 0; i < sheetLayersCopy.length; ++i) {
			objectLayers = objectLayers.concat(sheetLayersCopy[i]);
		}

		layerlist.html(objectLayers);
	}
}

var copyObjects = new Array();
/**
 * cmdPasteItems
 * @returns {undefined}
 */
function cmdPasteItems() {
	if(copyItems.length > 0) {
		var svg = document.getElementById('workarea');

		$.each(copyItems, function(index, node) {
			var groupNodes = this.childNodes;
			var childElements = false;

			for(var i = 0; i < groupNodes.length; ++i) {
				var element = groupNodes[i];
				var nodeId = element.getAttribute('id');
				var id = nodeId.split('_');

				if(id[0] === 'movie') {
					$.ajax({
						type: 'POST',
						url: serverName + '?page=presentations&cl=pasteItems',
						data: { item: nodeId },
						success: function(response) {
							if(response.success === true) {
								element.setAttribute('id', response.movieId);

								var id = (Math.random().toString(16) + "000000000").substr(2,10);
								node.setAttribute('id', id);
								svg.appendChild(node);

								saveSvg();
								refreshSheetContent();
							}
						},
						error: function() {
						}
					});
				} else {
					var tmpname = new Date().getTime();
					var id = id[0] + '_x_' + tmpname + '_' + parseInt(Math.random()*100);
					element.setAttribute('id', id);
					childElements = true;
				}
			}

			if(childElements === true) {
				var id = (Math.random().toString(16) + "000000000").substr(2,10);
				node.setAttribute('id', id);
				svg.appendChild(node);

				saveSvg();
				refreshSheetContent();
			}
		});
	}

	/*
	if(copyObjects != '') {
		$.each(copyObjects, function(index, node) {
			//alert(node);
			*
			var id = node.getAttribute('id').split('_');
			bindElement(node);
			group = makeGroup();
			$(group).append(node);
			*
		});
		// saveSvg();
	}
	*/
	/*
	if(copyItems == "") {
		return;
	}

	waitingOverlay('on');
	$.ajax({
		type: 'POST',
		url: serverName + '?page=presentations&cl=pasteItems',
		data: {
			pasteData: copyItems,
			copyAtThisSheet: copyAtThisSheet
		},
		success: function(newData) {
			copyItems = new Array();
			selectedItems = new Array();
			changeWorkContent(newData.cid);
			waitingOverlay('off');
		},
		error: function() {
			waitingOverlay('off');
		}
	});
	*/
}
/**
 * copy
 * @param {type} activeId
 * @returns {@exp;jQuery@call;toJSON}
 */
function copy(activeId) {
	$.each($('#workplace').find('#workarea g'), function() {
		var groupNodes = this.childNodes;

		for(var i = 0; i < groupNodes.length; ++i) {
			var element = groupNodes[i];
			if(element.getAttribute('id') == activeId) {
				copyObjects[0] = element;
			}
		}
	});

	/*
	copyAtThisSheet = lastID;
	copyItemsLocal = new Array();
	copyItemsLocal[0] = activeId;
	var objectToCopy = document.getElementById(activeId);
	params = activeId.split("_");

	// poprawka buga Chrome 16
	var cxVal,cyVal,rVal,rxVal,ryVal,fillVal,strokeVal,opacityVal,xVal,yVal,widthVal,heightVal,xlinkVal,dVal,strokedashVal,strokewidthVal;

    $.each(objectToCopy.attributes, function() {
        if (this.nodeName == "cx" && !cxVal) cxVal = this.value;
        else if (this.nodeName == "cy" && !cyVal) cyVal = this.value;
        else if (this.nodeName == "r" && !rVal) rVal = this.value;
        else if (this.nodeName == "rx" && !rxVal) rxVal = this.value;
        else if (this.nodeName == "ry" && !ryVal) ryVal = this.value;
        else if (this.nodeName == "fill" && !fillVal) fillVal = this.value;
        else if (this.nodeName == "stroke" && !strokeVal) strokeVal = this.value;
        else if (this.nodeName == "opacity" && !opacityVal) opacityVal = this.value;
        else if (this.nodeName == "x" && !xVal) xVal = this.value;
        else if (this.nodeName == "y" && !yVal) yVal = this.value;
        else if (this.nodeName == "width" && !widthVal) widthVal = this.value;
        else if (this.nodeName == "height" && !heightVal) heightVal = this.value;
        else if (this.nodeName == "xlink:href" && !xlinkVal) xlinkVal = this.value;
        else if (this.nodeName == "d" && !dVal) dVal = this.value;
        else if (this.nodeName == "stroke-dasharray" && !strokedashVal) strokedashVal = this.value;
        else if (this.nodeName == "stroke-width" && !strokewidthVal) strokewidthVal = this.value;
    });

    if(params[0] == "circle") {
        copyItemsLocal[1] = parseInt(cxVal);//cx
        copyItemsLocal[2] = parseInt(cyVal);//cy
        copyItemsLocal[3] = parseInt(rVal);//r
        copyItemsLocal[4] = fillVal;//fill
        copyItemsLocal[5] = strokeVal;//stroke
        copyItemsLocal[6] = opacityVal;//opacity
        copyItemsLocal[7] = objectToCopy.raphael.attrs.title;//title
    } else if(params[0] == "rect") {
        copyItemsLocal[1] = parseInt(xVal);//x
        copyItemsLocal[2] = parseInt(yVal);//y
        copyItemsLocal[3] = parseInt(widthVal);//width
        copyItemsLocal[4] = parseInt(heightVal);//height
        copyItemsLocal[5] = fillVal;//fill
        copyItemsLocal[6] = strokeVal;//stroke
        copyItemsLocal[7] = opacityVal;//opacity
        copyItemsLocal[8] = objectToCopy.raphael.attrs.title;//title
        copyItemsLocal[9] = parseInt(rVal);//r - radius
    } else if(params[0] == "ellipse") {
        copyItemsLocal[1] = parseInt(cxVal);//cx
        copyItemsLocal[2] = parseInt(cyVal);//cy
        copyItemsLocal[3] = parseInt(rxVal);//rx
        copyItemsLocal[4] = parseInt(ryVal);//ry
        copyItemsLocal[5] = fillVal;//fill
        copyItemsLocal[6] = strokeVal;//stroke
        copyItemsLocal[7] = opacityVal;//opacity
        copyItemsLocal[8] = objectToCopy.raphael.attrs.title;//title
    } else if(params[0] == "image" || params[0] == "chem" || params[0] == "math") {
        copyItemsLocal[1] = parseInt(xVal);//x
        copyItemsLocal[2] = parseInt(yVal);//y
        copyItemsLocal[3] = parseInt(widthVal);//width
        copyItemsLocal[4] = parseInt(heightVal);//height
        copyItemsLocal[5] = xlinkVal;//xlink
        copyItemsLocal[6] = opacityVal;//opacity
        copyItemsLocal[7] = objectToCopy.raphael.attrs.title;//title
    } else if(params[0] == "movie") {
        copyItemsLocal[1] = parseInt(xVal);//x
        copyItemsLocal[2] = parseInt(yVal);//y
        copyItemsLocal[3] = parseInt(widthVal);//width
        copyItemsLocal[4] = parseInt(heightVal);//height
        copyItemsLocal[5] = xlinkVal;//xlink
//        copyItemsLocal[6] = objectToCopy.attributes[8].value;//opacity
        copyItemsLocal[7] = objectToCopy.raphael.attrs.title;//title
    } else if(params[0] == "text") {
//        copyItemsLocal[1] = parseInt(objectToCopy.attributes[0].value);//x
//        copyItemsLocal[2] = parseInt(objectToCopy.attributes[1].value);//y
//        copyItemsLocal[3] = parseInt(objectToCopy.attributes[2].value);//width
//        copyItemsLocal[4] = parseInt(objectToCopy.attributes[3].value);//height
//        copyItemsLocal[5] = objectToCopy.attributes[6].value;//xlink
//        copyItemsLocal[6] = parseInt(objectToCopy.attributes[8].value);//opacity
    } else if(params[0] == "path") {
        copyItemsLocal[1] = dVal;//d
        copyItemsLocal[2] = 'none';//fillVal;//fill
        copyItemsLocal[3] = strokeVal;//stroke
        copyItemsLocal[4] = strokedashVal;//stroke-dasharray
        copyItemsLocal[5] = strokewidthVal;//stroke-width
        copyItemsLocal[6] = objectToCopy.raphael.attrs.title;//title
    }
    
    return  jQuery.toJSON(copyItemsLocal);
	*/
}


function maxBBox() {
    
}

/**
 * selectAll
 * @returns {undefined}
 */
function selectAll() {
	clearCorners();

	showElementAndHideRest('#emptyBox');

	if(iloscObiektow > 0) {
		customAlert("Zaznaczona liczba obiektów: " + iloscObiektow);
		selectedItems = new Array();
	} else {
		customAlert("Brak elementów do zaznaczenia.");
		return;
	}

	var j = 0;
	$.each($('#workplace').find('#workarea g'), function() {
		selectedItems[j] = this;
		j++;
	});

	var box = document.getElementById('workarea').getBBox();

	makeCorner(box.x, box.y, 'lt_corner');
	makeCorner(box.x, box.y + box.height, 'lb_corner');
	makeCorner(box.x + box.width, box.y, 'rt_corner');
	makeCorner(box.x + box.width, box.y + box.height, 'rb_corner');

	/*
    var x1 = workWidth;//0;
    var y1 = workHeight;//0;
    var x2 = 0;//workWidth;
    var y2 = 0;//workHeight;

    $("a",paper.canvas).each(function (){
        var box = this.getBBox();
        x1 = x1<box.x ? x1 : box.x;
        y1 = y1<box.y ? y1 : box.y;
        x2 = x2>box.x+box.width ? x2 : box.x+box.width;
        y2 = y2>box.y+box.height ? y2 : box.y+box.height;
    });

    $('#textplace').children('.textBoxItems').each(function(){
        var jqThis = $(this);
        var thisx= splitUnits( jqThis.css('left'))[1];
        var thisy= splitUnits( jqThis.css('top'))[1];
        var thiswidth= splitUnits( jqThis.css('width'))[1];
        var thisheight= splitUnits( jqThis.css('height'))[1];
        x1 = x1<thisx ? x1 : thisx;
        y1 = y1<thisy ? y1 : thisy;
        x2 = x2>thisx+thiswidth ? x2 : thisx+thiswidth;
        y2 = y2>thisy+thisheight ? y2 : thisy+thisheight;
    });

    //awaryjne przywracanie gdyby otaczanie obiektow zawiodlo
    x1 = x1 == workWidth ? 0 : x1;
    y1 = y1 == workHeight ? 0 : y1;
    x2 = x2 == 0 ? workWidth : x2;
    y2 = y2 == 0 ? workHeight : y2;

    var x3 = (x1+x2)/2;
    var y3 = (y1+y2)/2;

    var corner_lt = makeHandlerCircle( x1, y1, 'lt_corner', 5, '#CDCDCD');
    var corner_lb = makeHandlerCircle( x1, y2, 'lb_corner', 5, '#CDCDCD');
    var corner_rt = makeHandlerCircle( x2, y1, 'rt_corner', 5, '#CDCDCD');
    var corner_rb = makeHandlerCircle( x2, y2, 'rb_corner', 5, '#CDCDCD');   
    var line_ct = makeHandlerCircle( x3, y1, 'line_ct', 5, '#CDCDCD');
    var line_cb = makeHandlerCircle( x3, y2, 'line_cb', 5, '#CDCDCD');
    var line_cl = makeHandlerCircle( x1, y3, 'line_cl', 5, '#CDCDCD');
    var line_cr = makeHandlerCircle( x2, y3, 'line_cr', 5, '#CDCDCD');
	*/
}
